accept database_service char prompt "Please enter database service: "
accept sys_password char prompt "Please enter SYS password: " hide

prompt &database_service
prompt &sys_password

prompt sys/&sys_password@&database_service as sysdba
conn sys/&sys_password@&database_service as sysdba

create user demopaar identified by demopaar quota unlimited on users
/
grant create session, create procedure, create table, apex_administrator_role, alter session to demopaar
/
grant execute on dbms_lock to demopaar
/
grant execute on dbms_session to demopaar 
/

connect demopaar/demopaar@&database_service

set echo on

create function my_slow_function return number
is
begin
  -- Wait 1/100 sec
  dbms_lock.sleep(.01);
  return 42;
end;
/
create table mytable (id,name,status,mydate,filler)
as
 select level
      , 'Name ' || to_char(level)
      , mod(level,20) + 1
      , trunc(sysdate,'yyyy') + numtodsinterval(dbms_random.value * (trunc(sysdate)+1-trunc(sysdate,'yyyy')),'day')
      , lpad('*',1000,'*')
   from dual
connect by level <= 50000
/
create table mytable_details (id,mytable_id,name)
as
 select level
      , level
      , 'Name ' || to_char(level)
   from dual
connect by level <= 50000
/
alter table mytable add constraint mytable_pk primary key (id)
/
alter table mytable_details add constraint mytable_details_pk primary key (id)
/
alter table mytable_details add constraint mytable_details_mytable_fk foreign key (mytable_id) references mytable(id)
/
create index myindex on mytable(status,mydate)
/ 
create index mytable_details_fk_i on mytable_details(mytable_id)
/
exec dbms_stats.gather_table_stats(user,'mytable',cascade=>true)
exec dbms_stats.gather_table_stats(user,'mytable_details',cascade=>true)

create or replace package pagination_hack
as
  function min_row return pls_integer;
  function max_rows return pls_integer;
end pagination_hack;
/
create or replace package body pagination_hack
as
  function min_row return pls_integer
  is
  begin
    return wwv_flow.g_flow_current_min_row;
  end min_row
  ;
  function max_rows return pls_integer
  is
  begin
    return wwv_flow.g_flow_current_max_rows;
  end max_rows
  ;
end pagination_hack;
/

set echo off
prompt  A new schema called DEMOPAAR is created containing the objects needed for the demo.
prompt  When you press [Return], the schema and its objects will be removed.
pause

drop table mytable_details purge
/
drop table mytable purge
/
drop function my_slow_function
/
drop package pagination_hack
/
conn sys/&sys_password@&database_service as sysdba
drop user demopaar cascade
/
exit
